import os
from openai import OpenAI
import json

# 初始化 OpenAI 客户端
client = OpenAI(
    api_key=os.getenv("DASHSCOPE_API_KEY"),
    base_url="https://dashscope.aliyuncs.com/compatible-mode/v1",
)

# 获取文件列表
file_stk = client.files.list()

# 将文件信息解析为 JSON 格式
file_data = json.loads(file_stk.model_dump_json())

# 提取所有文件的 id
file_ids = [file["id"] for file in file_data["data"]]

# num=len(file_ids)
# print(num)
# 循环删除每个文件
for file_id in file_ids:
    file_object = client.files.delete(file_id)
    print(file_object.model_dump_json())
